Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_rot_vel.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_rot_vel.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_rot_vel.F90	(revision 15799)
@@ -16,4 +16,5 @@
    USE obs_utils                ! For error handling
    USE obs_profiles_def         ! Profile definitions
+   USE obs_surf_def             ! Surface definitions
    USE obs_inter_h2d            ! Horizontal interpolation
    USE obs_inter_sup            ! MPP support routines for interpolation
@@ -26,5 +27,6 @@
    PRIVATE
 
-   PUBLIC obs_rotvel            ! Rotate the observations
+   PUBLIC obs_rotvel_pro        ! Rotate the profile velocity observations
+   PUBLIC obs_rotvel_surf       ! Rotate the surface velocity observations
 
    !!----------------------------------------------------------------------
@@ -36,8 +38,8 @@
 CONTAINS
 
-   SUBROUTINE obs_rotvel( profdata, k2dint, pu, pv )
+   SUBROUTINE obs_rotvel_pro( profdata, k2dint, kuvar, kvvar, pu, pv )
       !!---------------------------------------------------------------------
       !!
-      !!                   *** ROUTINE obs_rea_pro_dri ***
+      !!                   *** ROUTINE obs_rotvel_pro ***
       !!
       !! ** Purpose : Rotate velocity data into N-S,E-W directorions
@@ -57,5 +59,7 @@
       !! * Arguments
       TYPE(obs_prof), INTENT(INOUT) :: profdata    ! Profile data to be read
-      INTEGER, INTENT(IN) :: k2dint     ! Horizontal interpolation methed
+      INTEGER, INTENT(IN) :: k2dint     ! Horizontal interpolation method
+      INTEGER, INTENT(IN) :: kuvar      ! Index of U velocity
+      INTEGER, INTENT(IN) :: kvvar      ! Index of V velocity
       REAL(wp), DIMENSION(*) :: &
          & pu, &
@@ -185,17 +189,17 @@
          zsin = 0.5_wp * ( zsinu(1) + zsinv(1) )
          
-         IF ( ( profdata%npvsta(ji,1) /= profdata%npvsta(ji,2) ) .OR. &
-            & ( profdata%npvend(ji,1) /= profdata%npvend(ji,2) ) ) THEN
+         IF ( ( profdata%npvsta(ji,kuvar) /= profdata%npvsta(ji,kvvar) ) .OR. &
+            & ( profdata%npvend(ji,kuvar) /= profdata%npvend(ji,kvvar) ) ) THEN
             CALL fatal_error( 'Different number of U and V observations '// &
                'in a profile in obs_rotvel', __LINE__ )
          ENDIF
 
-         DO jk = profdata%npvsta(ji,1), profdata%npvend(ji,1)
-            IF ( ( profdata%var(1)%vmod(jk) /= fbrmdi ) .AND. &
-               & ( profdata%var(2)%vmod(jk) /= fbrmdi ) ) THEN
-               pu(jk) = profdata%var(1)%vmod(jk) * zcos - &
-                  &     profdata%var(2)%vmod(jk) * zsin
-               pv(jk) = profdata%var(2)%vmod(jk) * zcos + &
-                  &     profdata%var(1)%vmod(jk) * zsin
+         DO jk = profdata%npvsta(ji,kuvar), profdata%npvend(ji,kuvar)
+            IF ( ( profdata%var(kuvar)%vmod(jk) /= fbrmdi ) .AND. &
+               & ( profdata%var(kvvar)%vmod(jk) /= fbrmdi ) ) THEN
+               pu(jk) = profdata%var(kuvar)%vmod(jk) * zcos - &
+                  &     profdata%var(kvvar)%vmod(jk) * zsin
+               pv(jk) = profdata%var(kvvar)%vmod(jk) * zcos + &
+                  &     profdata%var(kuvar)%vmod(jk) * zsin
             ELSE
                pu(jk) = fbrmdi
@@ -224,5 +228,188 @@
          & )
 
-   END SUBROUTINE obs_rotvel
+   END SUBROUTINE obs_rotvel_pro
+
+   SUBROUTINE obs_rotvel_surf( surfdata, k2dint, kuvar, kvvar, pu, pv )
+      !!---------------------------------------------------------------------
+      !!
+      !!                   *** ROUTINE obs_rotvel_surf ***
+      !!
+      !! ** Purpose : Rotate surface velocity data into N-S,E-W directorions
+      !!
+      !! ** Method  : Interpolation of geo2ocean coefficients on U,V grid
+      !!              to observation point followed by a similar computations
+      !!              as in geo2ocean.
+      !!
+      !! ** Action  : Review if there is a better way to do this.
+      !!
+      !! References : 
+      !!
+      !! History :  
+      !!      ! :  2009-02 (K. Mogensen) : New routine
+      !!----------------------------------------------------------------------
+      !! * Modules used
+      !! * Arguments
+      TYPE(obs_surf), INTENT(INOUT) :: surfdata    ! Surface data to be read
+      INTEGER, INTENT(IN) :: k2dint     ! Horizontal interpolation method
+      INTEGER, INTENT(IN) :: kuvar      ! Index of U velocity
+      INTEGER, INTENT(IN) :: kvvar      ! Index of V velocity
+      REAL(wp), DIMENSION(*) :: &
+         & pu, &
+         & pv
+      !! * Local declarations
+      REAL(wp), DIMENSION(2,2,1) :: zweig
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zmasku, &
+         & zmaskv, &
+         & zcoslu, &
+         & zsinlu, &
+         & zcoslv, &
+         & zsinlv, &
+         & zglamu, &
+         & zgphiu, &
+         & zglamv, &
+         & zgphiv
+      REAL(wp), DIMENSION(1) :: &
+         & zsinu, &
+         & zcosu, &
+         & zsinv, &
+         & zcosv
+      REAL(wp) :: zsin
+      REAL(wp) :: zcos
+      REAL(wp), DIMENSION(1) :: zobsmask
+      REAL(wp), DIMENSION(jpi,jpj) :: zsingu,zcosgu,zsingv,zcosgv
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
+         & igrdiu, &
+         & igrdju, &
+         & igrdiv, &
+         & igrdjv
+      INTEGER :: ji
+      INTEGER :: jk
+
+      !-----------------------------------------------------------------------
+      ! Allocate data for message parsing and interpolation
+      !-----------------------------------------------------------------------
+
+      ALLOCATE( &
+         & igrdiu(2,2,surfdata%nsurf), &
+         & igrdju(2,2,surfdata%nsurf), &
+         & zglamu(2,2,surfdata%nsurf), &
+         & zgphiu(2,2,surfdata%nsurf), &
+         & zmasku(2,2,surfdata%nsurf), &
+         & zcoslu(2,2,surfdata%nsurf), &
+         & zsinlu(2,2,surfdata%nsurf), &
+         & igrdiv(2,2,surfdata%nsurf), &
+         & igrdjv(2,2,surfdata%nsurf), &
+         & zglamv(2,2,surfdata%nsurf), &
+         & zgphiv(2,2,surfdata%nsurf), &
+         & zmaskv(2,2,surfdata%nsurf), &
+         & zcoslv(2,2,surfdata%nsurf), &
+         & zsinlv(2,2,surfdata%nsurf)  &
+         & )
+
+      !-----------------------------------------------------------------------
+      ! Receive the angles on the U and V grids.
+      !-----------------------------------------------------------------------
+
+      CALL obs_rot( zsingu, zcosgu, zsingv, zcosgv )
+
+      DO ji = 1, surfdata%nsurf
+         igrdiu(1,1,ji) = surfdata%mi(ji,1)-1
+         igrdju(1,1,ji) = surfdata%mj(ji,1)-1
+         igrdiu(1,2,ji) = surfdata%mi(ji,1)-1
+         igrdju(1,2,ji) = surfdata%mj(ji,1)
+         igrdiu(2,1,ji) = surfdata%mi(ji,1)
+         igrdju(2,1,ji) = surfdata%mj(ji,1)-1
+         igrdiu(2,2,ji) = surfdata%mi(ji,1)
+         igrdju(2,2,ji) = surfdata%mj(ji,1)
+         igrdiv(1,1,ji) = surfdata%mi(ji,2)-1
+         igrdjv(1,1,ji) = surfdata%mj(ji,2)-1
+         igrdiv(1,2,ji) = surfdata%mi(ji,2)-1
+         igrdjv(1,2,ji) = surfdata%mj(ji,2)
+         igrdiv(2,1,ji) = surfdata%mi(ji,2)
+         igrdjv(2,1,ji) = surfdata%mj(ji,2)-1
+         igrdiv(2,2,ji) = surfdata%mi(ji,2)
+         igrdjv(2,2,ji) = surfdata%mj(ji,2)
+      END DO
+
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, &
+         &                  glamu, zglamu )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, &
+         &                  gphiu, zgphiu )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, &
+         &                  umask(:,:,1), zmasku )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, &
+         &                  zsingu, zsinlu )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, &
+         &                  zcosgu, zcoslu )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, &
+         &                  glamv, zglamv )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, &
+         &                  gphiv, zgphiv )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, &
+         &                  vmask(:,:,1), zmaskv )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, &
+         &                  zsingv, zsinlv )
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, &
+         &                  zcosgv, zcoslv )
+
+      DO ji = 1, surfdata%nsurf
+            
+         CALL obs_int_h2d_init( 1, 1, k2dint, &
+            &                   surfdata%rlam(ji), surfdata%rphi(ji), &
+            &                   zglamu(:,:,ji), zgphiu(:,:,ji), &
+            &                   zmasku(:,:,ji), zweig, zobsmask )
+         
+         CALL obs_int_h2d( 1, 1, zweig, zsinlu(:,:,ji),  zsinu )
+
+         CALL obs_int_h2d( 1, 1, zweig, zcoslu(:,:,ji),  zcosu )
+
+         CALL obs_int_h2d_init( 1, 1, k2dint, &
+            &                   surfdata%rlam(ji), surfdata%rphi(ji), &
+            &                   zglamv(:,:,ji), zgphiv(:,:,ji), &
+            &                   zmaskv(:,:,ji), zweig, zobsmask )
+         
+         CALL obs_int_h2d( 1, 1, zweig, zsinlv(:,:,ji),  zsinv )
+
+         CALL obs_int_h2d( 1, 1, zweig, zcoslv(:,:,ji),  zcosv )
+
+         ! Assume that the angle at observation point is the 
+         ! mean of u and v cosines/sines
+
+         zcos = 0.5_wp * ( zcosu(1) + zcosv(1) )
+         zsin = 0.5_wp * ( zsinu(1) + zsinv(1) )
+
+         IF ( ( surfdata%rmod(ji,kuvar) /= fbrmdi ) .AND. &
+            & ( surfdata%rmod(ji,kvvar) /= fbrmdi ) ) THEN
+            pu(ji) = surfdata%rmod(ji,kuvar) * zcos - &
+               &     surfdata%rmod(ji,kvvar) * zsin
+            pv(ji) = surfdata%rmod(ji,kvvar) * zcos + &
+               &     surfdata%rmod(ji,kuvar) * zsin
+         ELSE
+            pu(ji) = fbrmdi
+            pv(ji) = fbrmdi
+         ENDIF
+
+
+      END DO
+      
+      DEALLOCATE( &
+         & igrdiu, &
+         & igrdju, &
+         & zglamu, &
+         & zgphiu, &
+         & zmasku, &
+         & zcoslu, &
+         & zsinlu, &
+         & igrdiv, &
+         & igrdjv, &
+         & zglamv, &
+         & zgphiv, &
+         & zmaskv, &
+         & zcoslv, &
+         & zsinlv  &
+         & )
+
+   END SUBROUTINE obs_rotvel_surf
 
 END MODULE obs_rot_vel
Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_surf_def.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_surf_def.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_surf_def.F90	(revision 15799)
@@ -23,4 +23,5 @@
    USE obs_mpp, ONLY : &  ! MPP tools 
       obs_mpp_sum_integer
+   USE obs_fbm            ! Obs feedback format
 
    IMPLICIT NONE
@@ -45,4 +46,5 @@
       INTEGER :: nsurfmpp   !: Global number of surface data within window
       INTEGER :: nvar       !: Number of variables at observation points
+      INTEGER :: nadd       !: Number of additional fields at observation points
       INTEGER :: nextra     !: Number of extra fields at observation points
       INTEGER :: nstp       !: Number of time steps
@@ -55,6 +57,4 @@
 
       INTEGER, POINTER, DIMENSION(:) :: &
-         & mi,   &        !: i-th grid coord. for interpolating to surface observation
-         & mj,   &        !: j-th grid coord. for interpolating to surface observation
          & mt,   &        !: time record number for gridded data
          & nsidx,&        !: Surface observation number
@@ -69,8 +69,31 @@
          & ntyp           !: Type of surface observation product
 
-      CHARACTER(len=8), POINTER, DIMENSION(:) :: &
-         & cvars          !: Variable names
-
-      CHARACTER(LEN=8), POINTER, DIMENSION(:) :: &
+      INTEGER, POINTER, DIMENSION(:,:) :: &
+         & mi,   &        !: i-th grid coord. for interpolating to surface observation
+         & mj             !: j-th grid coord. for interpolating to surface observation
+
+      CHARACTER(len=ilenname), POINTER, DIMENSION(:) :: &
+         & cvars,    &    !: Variable names
+         & cextvars, &    !: Extra variable names
+         & caddvars       !: Additional variable names
+
+      CHARACTER(len=ilenlong), POINTER, DIMENSION(:) :: &
+         & clong,    &    !: Variable long names
+         & cextlong       !: Extra variable long names
+
+      CHARACTER(len=ilenlong), POINTER, DIMENSION(:,:) :: &
+         & caddlong       !: Additional variable long names
+
+      CHARACTER(len=ilenunit), POINTER, DIMENSION(:) :: &
+         & cunit,    &    !: Variable units
+         & cextunit       !: Extra variable units
+
+      CHARACTER(len=ilenunit), POINTER, DIMENSION(:,:) :: &
+         & caddunit       !: Additional variable units
+
+      CHARACTER(len=ilengrid), POINTER, DIMENSION(:) :: &
+         & cgrid          !: Variable grids
+
+      CHARACTER(LEN=ilenwmo), POINTER, DIMENSION(:) :: &
          & cwmo           !: WMO indentifier
          
@@ -86,5 +109,8 @@
          & rext           !: Extra fields interpolated to observation points
 
-      REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
+      REAL(KIND=wp), POINTER, DIMENSION(:,:,:) :: &
+         & radd           !: Additional fields interpolated to observation points
+
+      REAL(KIND=wp), POINTER, DIMENSION(:,:,:) :: &
          & vdmean         !: Time averaged of model field
 
@@ -121,5 +147,5 @@
 CONTAINS
    
-   SUBROUTINE obs_surf_alloc( surf, ksurf, kvar, kextra, kstp, kpi, kpj )
+   SUBROUTINE obs_surf_alloc( surf, ksurf, kvar, kadd, kextra, kstp, kpi, kpj )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE obs_surf_alloc  ***
@@ -136,4 +162,5 @@
       INTEGER, INTENT(IN) :: ksurf   ! Number of surface observations
       INTEGER, INTENT(IN) :: kvar    ! Number of surface variables
+      INTEGER, INTENT(IN) :: kadd    ! Number of additional fields at observation points
       INTEGER, INTENT(IN) :: kextra  ! Number of extra fields at observation points
       INTEGER, INTENT(IN) :: kstp    ! Number of time steps
@@ -143,5 +170,5 @@
       !!* Local variables
       INTEGER :: ji
-      INTEGER :: jvar
+      INTEGER :: jvar, jadd, jext
 
       ! Set bookkeeping variables
@@ -149,4 +176,5 @@
       surf%nsurf    = ksurf
       surf%nsurfmpp = 0
+      surf%nadd     = kadd
       surf%nextra   = kextra
       surf%nvar     = kvar
@@ -158,9 +186,40 @@
 
       ALLOCATE( &
-         & surf%cvars(kvar)    &
+         & surf%cvars(kvar), &
+         & surf%clong(kvar), &
+         & surf%cunit(kvar), &
+         & surf%cgrid(kvar)  &
          & )
 
       DO jvar = 1, kvar
          surf%cvars(jvar) = "NotSet"
+         surf%clong(jvar) = "NotSet"
+         surf%cunit(jvar) = "NotSet"
+         surf%cgrid(jvar) = ""
+      END DO
+
+      ! Allocate additional/extra variable metadata
+
+      ALLOCATE( &
+         & surf%caddvars(kadd),      &
+         & surf%caddlong(kadd,kvar), &
+         & surf%caddunit(kadd,kvar), &
+         & surf%cextvars(kextra),    &
+         & surf%cextlong(kextra),    &
+         & surf%cextunit(kextra)     &
+         )
+         
+      DO jadd = 1, kadd
+         surf%caddvars(jadd) = "NotSet"
+         DO jvar = 1, kvar
+            surf%caddlong(jadd,jvar) = "NotSet"
+            surf%caddunit(jadd,jvar) = "NotSet"
+         END DO
+      END DO
+         
+      DO jext = 1, kextra
+         surf%cextvars(jext) = "NotSet"
+         surf%cextlong(jext) = "NotSet"
+         surf%cextunit(jext) = "NotSet"
       END DO
       
@@ -168,6 +227,4 @@
 
       ALLOCATE( &
-         & surf%mi(ksurf),      &
-         & surf%mj(ksurf),      &
          & surf%mt(ksurf),      &
          & surf%nsidx(ksurf),   &
@@ -187,4 +244,9 @@
          & )
 
+      ALLOCATE( &
+         & surf%mi(ksurf,kvar), &
+         & surf%mj(ksurf,kvar)  &
+         & )
+
       surf%mt(:) = -1
 
@@ -205,4 +267,12 @@
       surf%rext(:,:) = 0.0_wp 
 
+      ! Allocate arrays of number of additional fields at observation points
+
+      ALLOCATE( & 
+         & surf%radd(ksurf,kadd,kvar) &
+         & )
+
+      surf%radd(:,:,:) = 0.0_wp 
+
       ! Allocate arrays of number of time step size
 
@@ -215,5 +285,5 @@
 
       ALLOCATE( &
-         & surf%vdmean(kpi,kpj) &
+         & surf%vdmean(kpi,kpj,kvar) &
          & )
 
@@ -291,4 +361,10 @@
          & )
 
+      ! Deallocate arrays of number of additional fields at observation points
+
+      DEALLOCATE( & 
+         & surf%radd &
+         & )
+
       ! Deallocate arrays of size number of grid points size times
       ! number of variables
@@ -308,6 +384,20 @@
 
       DEALLOCATE( &
-         & surf%cvars     &
-         & )
+         & surf%cvars, &
+         & surf%clong, &
+         & surf%cunit, &
+         & surf%cgrid  &
+         & )
+
+      ! Dellocate additional/extra variables metadata
+
+      DEALLOCATE( &
+         & surf%caddvars, &
+         & surf%caddlong, &
+         & surf%caddunit, &
+         & surf%cextvars, &
+         & surf%cextlong, &
+         & surf%cextunit  &
+         )
 
    END SUBROUTINE obs_surf_dealloc
@@ -343,4 +433,5 @@
       INTEGER :: ji
       INTEGER :: jk
+      INTEGER :: jadd
       LOGICAL, DIMENSION(:), ALLOCATABLE :: llvalid
 
@@ -361,5 +452,5 @@
 
       IF ( lallocate ) THEN
-         CALL obs_surf_alloc( newsurf,  insurf, surf%nvar, &
+         CALL obs_surf_alloc( newsurf,  insurf, surf%nvar, surf%nadd, &
             & surf%nextra, surf%nstp, surf%npi, surf%npj )
       ENDIF
@@ -388,6 +479,6 @@
             insurf = insurf + 1
 
-            newsurf%mi(insurf)    = surf%mi(ji)
-            newsurf%mj(insurf)    = surf%mj(ji)
+            newsurf%mi(insurf,:)  = surf%mi(ji,:)
+            newsurf%mj(insurf,:)  = surf%mj(ji,:)
             newsurf%mt(insurf)    = surf%mt(ji)
             newsurf%nsidx(insurf) = surf%nsidx(ji)
@@ -410,4 +501,8 @@
                newsurf%rmod(insurf,jk)  = surf%rmod(ji,jk)
                
+               DO jadd = 1, surf%nadd
+                  newsurf%radd(insurf,jadd,jk) = surf%radd(ji,jadd,jk)
+               END DO
+               
             END DO
 
@@ -433,6 +528,15 @@
       ! Set book keeping variables which do not depend on number of obs.
 
-      newsurf%nstp     = surf%nstp
-      newsurf%cvars(:) = surf%cvars(:)
+      newsurf%nstp          = surf%nstp
+      newsurf%cvars(:)      = surf%cvars(:)
+      newsurf%clong(:)      = surf%clong(:)
+      newsurf%cunit(:)      = surf%cunit(:)
+      newsurf%cgrid(:)      = surf%cgrid(:)
+      newsurf%caddvars(:)   = surf%caddvars(:)
+      newsurf%caddlong(:,:) = surf%caddlong(:,:)
+      newsurf%caddunit(:,:) = surf%caddunit(:,:)
+      newsurf%cextvars(:)   = surf%cextvars(:)
+      newsurf%cextlong(:)   = surf%cextlong(:)
+      newsurf%cextunit(:)   = surf%cextunit(:)
       
       ! Set gridded stuff
@@ -470,4 +574,5 @@
       INTEGER :: jj
       INTEGER :: jk
+      INTEGER :: jadd
 
       ! Copy data from surf to old surf
@@ -475,8 +580,8 @@
       DO ji = 1, surf%nsurf
 
-         jj=surf%nsind(ji)
-
-         oldsurf%mi(jj)    = surf%mi(ji)
-         oldsurf%mj(jj)    = surf%mj(ji)
+         jj = surf%nsind(ji)
+
+         oldsurf%mi(jj,:)  = surf%mi(ji,:)
+         oldsurf%mj(jj,:)  = surf%mj(ji,:)
          oldsurf%mt(jj)    = surf%mt(ji)
          oldsurf%nsidx(jj) = surf%nsidx(ji)
@@ -500,8 +605,12 @@
          DO ji = 1, surf%nsurf
             
-            jj=surf%nsind(ji)
+            jj = surf%nsind(ji)
 
             oldsurf%robs(jj,jk)  = surf%robs(ji,jk)
             oldsurf%rmod(jj,jk)  = surf%rmod(ji,jk)
+               
+            DO jadd = 1, surf%nadd
+               oldsurf%radd(jj,jadd,jk) = surf%radd(ji,jadd,jk)
+            END DO
 
          END DO
@@ -513,5 +622,5 @@
          DO ji = 1, surf%nsurf
             
-            jj=surf%nsind(ji)
+            jj = surf%nsind(ji)
 
             oldsurf%rext(jj,jk)  = surf%rext(ji,jk)
